;*****************************************************************************
;*                      TUER-MELODIE-GONG-PROGRAMM                           *
;*                                                                           *
;*       PROGRAMM VON HANS JUERGEN KRETZSCHMAR (DL3UKH)                      *
;*                                                                           *
;*---------------------------------------------------------------------------*
;*                                                                           *
;*       VERSION GONG_01.ASM                                                 *
;*       NUR DAS ABSPEICHER / LESEN IN DEN FLASH-SPEICHER UND                *
;*       DAS AUSSENDEN / EMPFANGEN UEBER RS232                               *
;*       UND KLINGELKNOPF-AUSWERTUNG / LASTRELAIS-LED MUSS BRENNEN           *
;*                                                                           *
;*       VERSION GONG_02.ASM                                                 *
;*       ES KOMMT HINZU ZUR OBIGEN VERSION                                   *
;*       MELODIE ABSPIELEN FUER 8 MELODIEN UND 3 AUSWAHL-SCHALTERN           *
;*       WAHLWIEDERHOLUNG                                                    *
;*                                                                           *
;*       VERSION GONG_03.ASM                                                 *
;*       ES KOMMT HINZU ZUR OBIGEN VERSION                                   *
;*       24H/NORMAL-SCHALTER MIT INTERRUPT ALLER 0.5SEC                      *
;*                                                                           *
;*       VERSION GONG_04.ASM                                                 *
;*       ES HATTE GEBRUMMT MIT 200HZ WAEHREND DEN TOENEN.                    *
;*       DIE TONLAENGE WURDE JETZT NICHT STAENDIG IN MEHREREN TEILEN         *
;*       ABGEFRAGT BIS DIE TONLAENGE ZU ENDE IST. SONDERN ES                 *
;*       WURDE TIMER1 FUER EINEN VOLLSTAENDIGEN ZEITLAENGEN-DURCHLAUF        *
;*       BENUTZT.                                                            *
;*       DIESE VERSION IST QUATZSCH. ES LAG NICHT AM PROGRAMM.               *
;*       ES HAT NUR DER LAUTSPRECHER IM HOLZGEHAEUSE GESCHAEPPERT.           *
;*       ES LAG NUR AM LAUTSPRECHER-EINBAU.                                  *
;*                                                                           *
;*       VERSION GONG_05.ASM                                                 *
;*       ES KOMMT HINZU ZUR VERSION GONG_03.ASM                              *
;*       DIE PAUSEN ZWISCHEN DEN NOTEN/TOENEN WURDE VERBESSERT.              *
;*       IST DIE GESCH(WINDIGKEIT) SCHNELL SIND DIE PAUSEN KURZ.             *
;*       IST SIE LANGSAM SIND DIE PAUSEN LAENGER. ALSO ALLES PROPORTIONAL    *
;*                                                                           *
;*                                                                           *
;*       VERSION GONG_06.ASM                                                 *
;*       ES KOMMT HINZU ZUR VERSION GONG_05.ASM                              *
;*       DIE AUSWAHLSCHALTER AUF 5STCK. ERHOEHT                              *
;*       DABEI VERSCHIEBT SICH DER WAHLWIEDERHOL-SCHALTER USW....            *
;*       (SIEHE HIERZU STROMLAUFPLAN UND BESTUECKUNGSPLAN FR 32 MELODIEN)   *
;*       JETZT SIND 32 MELODIEN ABSPIELBAR UND SPEICHERBAR                   *
;*       ES GIBT NOCH 24STUNDEN-7-TAGE-WOCHENTAGS-ABSPIELUNG UND             *
;*       NOCH 24STUNDEN-32-TAGE-(MONATS-)ABSPIELUNG                          *
;*                                                                           *
;*                                                                           *
;*       DER QUARZ HAT 4MHZ ALSO T=0.25S  T==TAKTZEIT                       *
;*                                                                           *
;*****************************************************************************

	LIST  	P=16F876	
	TITLE	"TUERGONG"

	INCLUDE	<P16F876.INC>
	ERRORLEVEL -302


;PROGRAMMIEREINSTELLUNGEN:
;OSZILLATOR             XS
;WATCHDOG               OFF
;POWER-UP-TIMER         OFF
;CODE PORTECT           OFF
;BROWN-OUT DETECT       OFF
;LOW VOLTAGE PROGRAMM   DISABLE
;DATA EE PROTECT        OFF
;FLASH PROGRAMM WRITE   ENABLE ==> MAN KANN AUF DEN FLASH-SPEICHER DIE NOTEN SCHREIBEN
;BACKGROUND DEBUG       DISABLE



;PORTZUORDNUNG==>

;EING.	PORTA	RA0	NICHT BELEGT
;EING.	PORTA	RA1	NICHT BELEGT
;EING.	PORTA	RA2	NICHT BELEGT
;EING.	PORTA	RA3	NICHT BELEGT
;EING.	PORTA	RA4	NICHT BELEGT
;EING.	PORTA	RA5	NICHT BELEGT
;
;EING.	PORTB	RB0	MELODIEAUSWAHL UND WOCHENTAGS- MONATS-ABSPIELUNG
;EING.	PORTB	RB1	MELODIEAUSWAHL
;EING.	PORTB	RB2	MELODIEAUSWAHL
;EING.	PORTB	RB3	MELODIEAUSWAHL
;EING.	PORTB	RB4	MELODIEAUSWAHL
;EING.	PORTB	RB5	MELODIEWIEDERHOLUNG        
;EING.	PORTB	RB6	MELODIE WECHSELT ALLER 24H ODER MIT MELODIEAUSWAHL EINE MELODIE NUTZEN
;EING.	PORTB	RB7	KLINGKNOPFSPANNUNGS-AUSWERTUNG BEI LOW 5SEC DANACH ERKLINGT MELODIE
;			
;AUSG.	PORTC	RC0	MELODIE NF-AUSGANGSSPANNUNG	
;AUSG.	PORTC	RC1	LASTRELAIS-ZUSCHALTUNG BEI HIGH NACH 4SEC NACHDEM KLINGELDRUCK ERFOLGT IST, NF-VERSTAERKERSPANNUNG EIN
;EING.	PORTC	RC2	NICHT BELEGT
;AUSG.	PORTC	RC3	LED-BLITZT 0,5SEC JEDE SEC AUF, WENN 24H-MELODIE-EINSTELLUNG EINGESTELLT IST
;EING.	PORTC	RC4	CTS-RS232-EING.
;AUSG.	PORTC	RC5	RTS-RS232-AUSG.
;AUSG.	PORTC	RC6	TXD-RS232
;EING.	PORTC	RC7	RXD-RS232


;---------------------------------------------------------------------------------
;VARIABLEN
BIT0		EQU	0
BIT1		EQU	1
BIT2		EQU	2
BIT3		EQU	3
BIT4		EQU	4
BIT5		EQU	5
BIT6		EQU	6
BIT7		EQU	7

MEL_L		EQU	0X70	;FUER MELODIE-ADRESSEN-BERECHNUNG
MEL_H		EQU	0X03	;BEGINNT MIT MELODIEN AB 0X0370
				;IM 13-BIT SPEICHER STEHT:
				;8BIT-LOW NOTE
				;5BIT-HIGH LAENGE

MEG_L		EQU	0X40	;FUER MELODIEN-GESCHWINDIGKEITS-ADRESSEN-BERECHNUNG
MEG_H		EQU	0X03	;BEGINNT MIT GESCHWINDIGKEIT AB 0X0340

M_LAEN		EQU	D'228'	;MAX. MELODIE-LAENGE MIT DEZ 228 VORSEHEN
				;228*32 MOEGLICHE MELODIEN = 7296DEZ / 1C80HEX
				;1C80HEX + 0370HEX =1FF0HEX ==> ENDE 0X1FFF NICHT ERREICHT
				;ES GEHT SO

K_BYT1          EQU     0XAA    ;1-TES KENNUNGSBYTE
K_BYT2          EQU     0X55    ;2-TES KENNUNGSBYTE
K_BYT3          EQU     0X03    ;3-TES KENNUNGSBYTE


RTS_OUTPUT	EQU	5	;PORT C PIN 5 OUTPUT FUER RS232 
CTS_INPUT	EQU	4	;PORT C PIN 4 INPUT FUER RS232

BAUD_CONSTANT	EQU	D'207'	;CONSTANT FOR BAUD GENERATOR FOR 300 BAUD
;BERECHNUNG BEI LOW SPEED  //BRGH=0
;BAUDRATE=FOSZ/(64(BAUD_CONSTANT+1))
;300.480BAUD=4MHZ/(64(207+1))

;----------------------------------------------------------------------------

;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ALSO RAM-SPEICHER ZUORDNUNG

	ORG 20H 

;ALLES FUERS SPEICHERN
MERK1		RES	1  	;NORMALE HILFSZELLE

ADRX_L		RES	1 	;FLASH-SPEICHER-ADRESSE NOTE+LAENGE
ADRX_H		RES	1 	

ADRY_L		RES	1	;ADRESSEN-MERKER
ADRY_H		RES	1

ADRG_L		RES	1	;FLASH-SPEICHER-ADRESSE GESCHWINDIGKEIT
ADRG_H		RES	1	

ADR_L		RES	1	;DIREKT ZUM SCHREIBEN UND LESEN DIE ADRESSENMERKER
ADR_H		RES	1

DAT		RES	1	;GELESENE UND GESENDETE DATEN VON RS232

DAT_L		RES	1	;FUER FLASH-READ + WRITE
DAT_H		RES	1

MERK3		RES	1	;MERKER FUER AUSWAHLSCHALTER-VERGLEICH / ADRESSEN-BERECHNUNG

;ALLES FUER MELODIE
GESCH		RES	1	;GESCHWINDIGKEIT WIE SCHNELL DIE MELODIE ABGESPIELT WERDEN SOLL
NO		RES	1	;TONHOEHE BZW. NOTE
LA		RES	1	;TONLAENGE
ZAE		RES	1	;ZAEHLER FUER JEDE HALBE PERIODE
MERK2		RES	1	;GESCHWINDIGKEITS-MERKER
ANZ		RES	1	;BIT7-WAHLWIEDERHOLUNG
				;BIT3 -MERKER FUER TONLAENGENZEIT ABGELAUFEN

;FUER 0.5SEC SEC-INTERRUPT+24HSCHALTER
W_STACK		RES	1	;STACK FUER POP+PUSH
S_STACK		RES	1	;STACK FUER POP+PUSH
SEC1		RES	1	;0.5SEC ZAEHLER
SEC2		RES	1	;10SEC ZAEHLER
MIN		RES	1	;MINUTEN ZAEHLER
H		RES	1	;STUNDEN ZAEHLER
NR		RES	1	;MELODIE-NUMMER AENDERT SICH NACH 24H
HELP		RES	1	;BIT0 FLIPFLOP-MERKER, NUR EINMAL INIT VOM INTERRUPT+TIMER1
				;BIT3 FUER MONAT-WOCHEN-UMSCHALTUNG
				;BIT7 0.5SEC LED BLITZ

;------------------------- MACROS -------------------------------------------------

BANK0		MACRO			;MACRO TO SELECT DATA RAM BANK 0
		BCF	STATUS,RP0
		BCF	STATUS,RP1
		ENDM

BANK1		MACRO			;MACRO TO SELECT DATA RAM BANK 1
		BSF	STATUS,RP0
		BCF	STATUS,RP1
		ENDM

BANK2		MACRO			;MACRO TO SELECT DATA RAM BANK 2
		BCF	STATUS,RP0
		BSF	STATUS,RP1
		ENDM

BANK3		MACRO			;MACRO TO SELECT DATA RAM BANK 3
		BSF	STATUS,RP0
		BSF	STATUS,RP1
		ENDM

;----------------------------------------------------------------------------

PUSH		MACRO
		MOVWF 	W_STACK
		MOVF	STATUS, W
		MOVWF	S_STACK
		ENDM

POP		MACRO
		MOVF	S_STACK, W
		MOVWF	STATUS
		SWAPF	W_STACK, F
		SWAPF	W_STACK, W
		ENDM

;------------------------- ENDE MACROS --------------------------------------------

;------------------------- PROGRAMM -----------------------------------------------

;START VOM HAUPTPROGRAMM (MAIN) 

	ORG 0X0000
	GOTO 	MAIN			; SPRUNG ZUM HAUPTPROGRAMM
	ORG 0X0004
	GOTO	INTERR			; SPRUNG ZUM INTERRUPT

	ORG 0X0010
;*****************************************************************************
;*                              INTERRUPT-PROGRAMM                           *
;*                              19.09.05                                     *
;*****************************************************************************
INTERR	PUSH
	BCF	T1CON, TMR1ON		;TIMER1 ANHALTEN
	MOVLW	0XD8			;500MS/32=15.625MS/0.25S=62500TAKTE
	MOVWF	TMR1L			;0X10000-62500(0XF424)=0X0BDC  +(JUSTAGE)==0X0BD8
	MOVLW	0X0B
	MOVWF	TMR1H
	BCF	PIR1, TMR1IF		;OVERFLOW 0 MACHEN
	BSF	T1CON, TMR1ON		;TIMER1 STARTEN

	BCF	HELP, BIT7		;MERKER LED LOESCHEN

	BTFSS	PORTB, BIT0		;ABFRAGE OB 24H-WOCHEN- ODER MONATS-ABSPIELUNG
	GOTO	MON
	
	BTFSC	HELP, BIT3		;UMSCHALTEN
	GOTO	INT2			

	BSF	HELP, BIT0		;NUR EINMAL FLIP/FLOP AUSSCHALTEN
	CALL	I_EIN

	BSF	HELP, BIT3		;MERKER FUER WOCHE BEI UMSCHALTUNG
INT2	DECFSZ	SEC1, F
	GOTO	IX1
	MOVLW	D'2'			;10SEC WIEDER LADEN
	MOVWF	SEC1
	BSF	HELP, BIT7		;MERKER LED BLITZT 0.5SEC ALLER 1SEC AUF

	DECFSZ	SEC2, F
	GOTO	IX1
	MOVLW	D'60'			;JETZT SIND ES WIEDER 60SEC-ZEIT
	MOVWF	SEC2

	DECFSZ	MIN, F
	GOTO	IX1
	MOVLW	D'60'			;JETZT SIND ES WIEDER 60MIN-ZEIT
	MOVWF	MIN

	DECFSZ	H, F
	GOTO	IX1
	MOVLW	D'24'			;JETZT SIND ES WIEDER 24H-ZEIT
	MOVWF	H

	INCF	NR, F

	MOVLW	D'7'
	SUBWF	NR, W
	BTFSS	STATUS, Z
	GOTO	IX1
	MOVLW	D'0'			;BEGINNT WIEDER BEI MELODIENUMMER 0
	MOVWF	NR
	GOTO	IX1

MON	BTFSS	HELP, BIT3		;UMSCHALTEN
	GOTO	INT4			

	BSF	HELP, BIT0		;NUR EINMAL FLIP/FLOP AUSSCHALTEN
	CALL	I_EIN			;JETZT WOCHE

	BCF	HELP, BIT3		;MERKER FUER MONAT BEI UMSCHALTUNG
INT4	DECFSZ	SEC1, F
	GOTO	IX1
	MOVLW	D'6'			;6*0.5SEC=3SEC WIEDER LADEN
	MOVWF	SEC1
	BSF	HELP, BIT7		;MERKER LED BLITZT 0.5SEC AUF

	DECFSZ	SEC2, F
	GOTO	IX1
	MOVLW	D'20'			;JETZT SIND ES WIEDER 60SEC-ZEIT
	MOVWF	SEC2

	DECFSZ	MIN, F
	GOTO	IX1
	MOVLW	D'60'			;JETZT SIND ES WIEDER 60MIN-ZEIT
	MOVWF	MIN

	DECFSZ	H, F
	GOTO	IX1
	MOVLW	D'24'			;JETZT SIND ES WIEDER 24H-ZEIT
	MOVWF	H

	INCF	NR, F

	MOVLW	D'32'
	SUBWF	NR, W
	BTFSS	STATUS, Z
	GOTO	IX1
	MOVLW	D'0'			;BEGINNT WIEDER BEI MELODIENUMMER 0
	MOVWF	NR

IX1	BTFSS	HELP, BIT7
	GOTO	IX2
	BSF	PORTC, BIT3		;LED AN
	GOTO	IX3

IX2	BCF	PORTC, BIT3		;LED AUS

IX3	POP
	RETFIE
;*****************************************************************************
;*                              HAUPTPROGRAMM                                *
;*                              15.07.05                                     *
;*****************************************************************************

;----------- INIT ALLE PORT'S ----------------------------------------------------

MAIN	CLRF	PORTA			;ANFANGSZUSTAND
	CLRF	PORTB		
	CLRF	PORTC

	BANK1

	MOVLW	0X06			;ALLES DIGITALE I/O (0X06) ,KEIN AD-PORT
	MOVWF	ADCON1

	MOVLW 	B'11111111'		;INIT I/O PORT A ALLES EINGAENGE NICHT BENUTZT
	MOVWF 	TRISA

	MOVLW	B'11111111'		;INIT I/O PORT B ALLES EINGAENGE
	MOVWF	TRISB

	MOVLW	B'10010100'		;INIT I/O PORT C ALLES AUSGAENGE // BIT 7 UND 4 UND 2 EINGANG
	MOVWF	TRISC

;TIMER0-SETUP
	MOVLW	B'00000111'		;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 0=PULL-UPS ENABLE 
	MOVWF	OPTION_REG	

;SERIALSETUP

	MOVLW	BAUD_CONSTANT		;SET BAUD RATE 300BAUD FOR 4MHZ CLOCK , ERROR 0%
	MOVWF	SPBRG
	BCF	TXSTA, BRGH		;BAUD RATE LOW SPEED OPTION
	BSF	TXSTA, TXEN		;ENABLE TRANSMISSION
	BCF	TXSTA, SYNC		;MUSSNOCH REIN LAUT DATENBLATT-BESCHREIBUNG
	BCF	TXSTA, TX9D		;KEINE 9BIT UEBERTRAGUNG

	BANK0				;CHANGE FROM BANK1 TO BANK0
	BSF	RCSTA, CREN		;ENABLE RECEPTION // UNUNTERBROCHENER EMPFANG
	BSF	RCSTA, SPEN		;ENABLE SERIAL PORT
	BCF	RCSTA, RX9D		;KEINE 9BIT UEBERTRAGUNG
;--------------------

	BCF	PORTC, BIT1		;NF-NETZTEIL AUSSCHALTEN
	BCF	PORTC, BIT3		;24H-LED LEUCHTET JETZT NICHT	
	BCF	PORTC, BIT0		;NF AUS

	BCF	INTCON, T0IE		;KEIN INTERRUPT TIMER0

ANF01	BCF	HELP, BIT0		;DAMIT I_AUS AUCH WIRKSAM IST
	CALL	I_AUS

;------------- KLINGELKNOPF-AUSWERTUNG -------------------------------------------
ANF0	BTFSS	PORTB, BIT6		;INTERRUPT+TIMER-INIT DURCH EINZEL-/24H- SCHALTER EINSTELLEN
	GOTO	ANF0A			;BEI LOW I_EIN
	CALL	I_AUS			;BEI HIGH I_AUS  ALLES NUR EINMAL INIT

ANF0B	BTFSS	PORTB, BIT7		;KLINGELKNOPFSPANNUNG AUSWERTUNG, BEI LOW SPIELT ES MELODIE
	GOTO	ANF2	
	BTFSS	HELP, BIT0		;BEI HIGH KANN MAN DATEN AM RS232-PORT EMPFANGEN / ALSO ABFRAGE
	GOTO	ANF0			
	BTFSS	PIR1,RCIF		;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
	GOTO	ANF0			;BEI NEIN ZUM ANFANGSWARTEN AUF KLINGELKNOPFSP. USW.
	BSF	PORTC,RTS_OUTPUT 	;RTS WIRD AM MAX232 LOW, SPERRT DAS AUSSENDEN DES PC'S
	GOTO	ABSP

ANF0A	CALL	I_EIN	
	GOTO	ANF0B


ANF2	BSF	PORTC,RTS_OUTPUT 	;RTS WIRD AM MAX232 LOW, SPERRT DAS AUSSENDEN DES PC'S

;ENTPRELLEN DAUER 100MS / ES MUSS MIND. 100MS KLINGEL STAENDIG GEDRUECKT SEIN
	MOVLW	D'10'		
	MOVWF	MERK1			
ENTP1	CALL	T10_I
	BTFSC	PORTB, BIT7
	GOTO	ANF0
ENTP2	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT VON 10MS
	GOTO	ENTP2		
	DECFSZ	MERK1, F
	GOTO	ENTP1

ANF5B	CALL	ABF			;AUS AUSWAHL-SCHALTERSTELLUNG MELODIE-ANFANGS-ADRESSE BERECHNEN
	MOVF	ADRX_L, W		;NOTEN+LAENGEN-ADRESSEN-BEGINN MERKEN
	MOVWF	ADRY_L
	MOVF	ADRX_H, W
	MOVWF	ADRY_H

;WIEDERHOL-SCHALTER ABFRAGEN UND WIEDERHOLUNG SETZEN BEI 2X SPIELEN
	BCF	ANZ, BIT7		
	BTFSC	PORTB, BIT5
	BSF	ANZ, BIT7

ANF5A	MOVLW	D'200'
	MOVWF	MERK1
ANF3	CALL	T10_I			;TIMER0 STARTEN
ANF4	BTFSS	PORTB, BIT7		;LETZTES DRUECKEN VOM KLINGELKNOPF WIRD ABGEWARTET
	GOTO	ANF5B			
	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT VON 10MS
	GOTO	ANF4			;BEI NEIN ZUM ANFANGSWARTEN AUF KLINGELKNOPFSP. USW.
	DECFSZ	MERK1, F		;MAN ZAEHLT RUNTER BIS 10MS * MERK1 = 2SEC ERREICHT SIND
	GOTO	ANF3

	MOVLW	D'200'
	MOVWF	MERK1
ANF3A	CALL	T10_I			;TIMER0 STARTEN
ANF4A	BTFSS	PORTB, BIT7		;LETZTES DRUECKEN VOM KLINGELKNOPF WIRD ABGEWARTET
	GOTO	ANF5B
	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT VON 10MS
	GOTO	ANF4A			;BEI NEIN ZUM ANFANGSWARTEN AUF KLINGELKNOPFSP. USW.
	DECFSZ	MERK1, F		;MAN ZAEHLT RUNTER BIS 10MS * MERK1 = 2SEC ERREICHT SIND
	GOTO	ANF3A


  	
;------------- 1 SEC VORHER DAS NETZTEIL DES NF-VERSTAERKERS ANSCHALTEN --------------
;--------------------
	BSF	PORTC, BIT1		;NF-NETZTEIL EINGESCHALTEN
;--------------------

	MOVLW	D'100'			;ZEITEINSTELLUNG VON 1SEC
	MOVWF	MERK1		
ANF6	CALL	T10_I			;TIMER0 MIT DER ZEIT 10MS STARTEN UND
ANF5	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT VON 10MS
	GOTO	ANF5			;BEI NEIN ZUM ANFANGSWARTEN AUF KLINGELKNOPFSP. USW.
	DECFSZ	MERK1, F		;MAN ZAEHLT RUNTER BIS 10MS * MERK1 = 1SEC ERREICHT SIND
	GOTO	ANF6



;------------- HIER KOMMT JETZT DAS ABSPIELEN DER MELODIE ----------------------

AU1	BCF	INTCON, GIE		;INTERRUPT ABSCHALTEN SO WIE ES IM BUCH STEHT
	BTFSC	INTCON, GIE
	GOTO	AU1
	BSF	PORTC, BIT3		;LED WAEHREND DES ABSPIELEN AN

MELO	MOVF	ADRY_L, W		;NOTEN+LAENGEN-ADRESSEN-BEGINN ALS AKTUELL IN ADRX
	MOVWF	ADRX_L
	MOVF	ADRY_H, W
	MOVWF	ADRX_H


;GESCHWINDIGKEIT (GESCH) MIT ADRG_L UND ADRG_H VOM SPEICHER LESEN
	MOVF	ADRG_L, W
	MOVWF	ADR_L
	MOVF	ADRG_H, W
	MOVWF	ADR_H
	CALL	READ
	MOVF	DAT_L, W
	MOVWF	GESCH

;NEUE NOTE SPIELEN
NEU_NO	BCF	ANZ, BIT3		;RUECKSETZEN TON-LAENGENZEIT IST ABGELAUFEN
	BCF	MERK1, BIT7		;NOTENPAUSEN MERKER RUECKSETZEN
	BCF	PORTC, BIT0		;NF AUS

;TONLAENGE + NOTE WIRD AUS SPEICHER GELESEN
	MOVF	ADRX_L, W
	MOVWF	ADR_L
	MOVF	ADRX_H, W
	MOVWF	ADR_H
	CALL	READ

;MELODIE ENDE ERKENNUNG
	MOVLW	0XFF
	SUBWF	DAT_L, W		;ACHTUNG NUR IN DAT_L HERKOMMEND VON READ STEHT DAS ENDEBYTE 0XFF
	BTFSS	STATUS, Z
	GOTO	NO_AUSW			;NICHT ZUR AUSWERTUNG GEHEN OB MELODIE 2X SPIELEN

;WIEDERHOL-SCHALTER ABFRAGEN UND WIEDERHOLUNG SETZEN BEI 2X SPIELEN
	BTFSS	ANZ, BIT7
	GOTO	AA0			;BEENDEN ZUR KLINGELABFRAGE AN DEN ANFANG
	BCF	ANZ, BIT7		;NUR NOCH 1X
	GOTO	MELOD

AA0	BTFSS	HELP, BIT0		;ABFRAGE OB I_AUS ODER I_EIN ZU LETZT AKTIV WAREN
	GOTO	AAI

	BCF	PORTC, BIT1		;NF-NETZTEIL AUSGESCHALTEN	
	BCF	PORTC, BIT3		;LED WAEHREND DES ABSPIELEN WAR AN JETZT AUSSCHALTEN
	BCF	PORTC,RTS_OUTPUT 	;RTS WIRD AM MAX232 HIGH, DAS AUSSENDEN DES PC'S JETZT WIEDER MOEGLICH
	GOTO	ANF0

AAI	BSF	INTCON, GIE		;INTERRUPT WIEDER ANSCHALTEN
	BCF	PORTC, BIT1		;NF-NETZTEIL AUSGESCHALTEN	
	BCF	PORTC, BIT3		;LED WAEHREND DES ABSPIELEN WAR AN JETZT AUSSCHALTEN
	GOTO	ANF0

NO_AUSW	CALL	LAENGE
	MOVWF	LA			;TONLAENGE ABSPEICHERN IN LA
	MOVLW 	H'00'			;ADRESSE SPEICHERN NEUES PCLATH
	MOVWF 	PCLATH

;TONHOEHE (HIER ALS N, WIE NOTE, ALSO WIE ADRN ) WIRD AUS SPEICHER GELESEN
	CALL	HOEHE
	MOVWF	NO			;NOTE ODER TONHOEHE ABSPEICHERN IN NO
	MOVLW 	H'00'			;ADRESSE SPEICHERN NEUES PCLATH
	MOVWF 	PCLATH

;GLEICH NEUE NOTEN+LAENGEN-ADRESSE FUER KOMMENDE NOTE+LAENGE ERRECHNEN
	INCFSZ	ADRX_L, F		;IMMER 1 WEITERZAEHLEN ALSO NEUE NOTE BZW. TONHOEHEN-SPEICHERADRESSE
	GOTO	M0
	INCF	ADRX_H, F

;NACHFRAGEN OB EINE NOTEN-PAUSE VORLIEGT
M0	MOVLW	0X00
	SUBWF	NO, W
	BTFSC	STATUS, Z
	BSF	MERK1, BIT7		;NOTENPAUSEN MERKER SETZEN

;MELODIE WIRD JETZT AUSGEGEBEN, VORHER WURDEN ALLE DATEN ZWISCHENGESPEICHERT //NO LA + MERK1-BIT7 
SPIELE	MOVF	GESCH, W
	MOVWF	MERK2

SPIE1	CALL	T3_I			;3MS PAUSE ZWISCHEN DEN EINZELNEN NOTEN
SPIE2	BTFSS	INTCON, T0IF		;UND DANN MIT GESCH(WINDIGKEIT) MULTIPLIZIERT
	GOTO	SPIE2			;BEI GESCH=15 ==> 15*3MS=45MS PAUSE // ALSO PROPORTIONAL ZUM TEMPO

	DECFSZ	MERK2, F
	GOTO	SPIE1

	CALL	T5_I
	MOVF	GESCH, W
	MOVWF	MERK2

SP0	MOVF	NO, W
	MOVWF	ZAE
	BTFSS	MERK1, BIT7		;BEI PAUSE KEINE NF
	BSF	PORTC, BIT0		;NF EIN


SP1	NOP				;4T
	NOP				;4T
	NOP				;4T
	NOP				;4T
	NOP				;4T GES.: 20T

	NOP				;4T
	NOP				;4T
	NOP				;4T GES.: 32

	BTFSC	INTCON, T0IF		;8T BEI SPRUNG   GES.:40T
	CALL	Z_LAEN

	BTFSC	ANZ, BIT3		;8T BEI SPRUNG   GES.:48T
	GOTO	NEU_NO

	DECFSZ	ZAE, F			;4T
	GOTO	SP1			;8T GESAMT:60T  /// 60T*0.25S=15S

	MOVF	NO, W			
	MOVWF	ZAE			
	BTFSS	MERK1, BIT7		;BEI PAUSE KEINE NF  
	BCF	PORTC, BIT0		;NF AUS              

SP2	NOP				;4T
	NOP				;4T
	NOP				;4T
	NOP				;4T
	NOP				;4T GES.: 20T

	NOP				;4T
	NOP				;4T
	NOP				;4T GES.: 32

	BTFSC	INTCON, T0IF		;8T BEI SPRUNG   GES.:40T
	CALL	Z_LAEN

	BTFSC	ANZ, BIT3		;8T BEI SPRUNG   GES.:48T
	GOTO	NEU_NO

	DECFSZ	ZAE, F			;4T
	GOTO	SP2			;8T GESAMT:60T  /// 60T*0.25S=15S
	GOTO	SP0


;------------- HIER KOMMT JETZT DAS ABSPEICHERN DER MELODIE ----------------------
ABSP	BSF	PORTC, BIT3		;SPEICHERKONTROLL-LED LEUCHTET JETZT
	CALL	ABF
	CLRF	MERK1

ABSPE1	CALL	F_RX
	BTFSS	MERK1, BIT7
	GOTO	ABSPE1

	BCF	MERK1, BIT7		;K_BYT1 FUER KENNUNG VERGLEICHEN
	MOVWF	DAT

	MOVLW	K_BYT1
	SUBWF	DAT, W
	BTFSS	STATUS, Z
	GOTO	ANF01

	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN
	MOVLW	D'10'
	MOVWF	MERK1

ANFZ	CALL	T10_I

ANFD	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT
	GOTO	ANFD1	
	DECFSZ	MERK1, F		;MAN ZAEHLT RUNTER BIS 10MS * MERK1 = 100MS ERREICHT SIND
	GOTO	ANFZ
	GOTO	ANF01

ANFD1	CALL	F_RX
	BTFSS	MERK1, BIT7
	GOTO	ANFD

	BCF	MERK1, BIT7		;K_BYT2 FUER KENNUNG VERGLEICHEN
	MOVWF	DAT

	MOVLW	K_BYT2
	SUBWF	DAT, W
	BTFSS	STATUS, Z
	GOTO	ANF01

	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN

	MOVLW	D'10'
	MOVWF	MERK1

ANFA	CALL	T10_I

ANFB	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT
	GOTO	ANFB1	
	DECFSZ	MERK1, F		;MAN ZAEHLT RUNTER BIS 10MS * MERK1 = 100MS ERREICHT SIND
	GOTO	ANFA
	GOTO	ANF01

ANFB1	CALL	F_RX
	BTFSS	MERK1, BIT7
	GOTO	ANFB

	BCF	MERK1, BIT7		;K_BYT3 FUER KENNUNG VERGLEICHEN
	MOVWF	DAT

	MOVLW	K_BYT3
	SUBWF	DAT, W
	BTFSS	STATUS, Z
	GOTO	ANF01

	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN

;RICHTIGE DATEN LESEN UND IM FLASH-SPEICHER ABSPEICHERN
ANFY	CALL	F_RX			;WAS ABGESPEICHERT WERDEN SOLL WIRD GELESEN
	BTFSS	MERK1, BIT7		;BEI HIGH HAT ES GELESEN
	GOTO	ANFY

	MOVWF	DAT
	BCF	MERK1, BIT7		;WIEDER LESE-ERKENNUNG ZURUECK GESETZT WERDEN

	MOVLW	0XC0			;ES SOLL NUR GELESEN WERDEN	
	SUBWF	DAT, W
	BTFSC	STATUS, Z
	GOTO	LESE			;ZUM AUSLESEN+SENDEN GEHEN

	MOVF	ADRG_L, W
	MOVWF	ADR_L
	MOVF	ADRG_H, W
	MOVWF	ADR_H

	MOVLW	0X00			;IN HIGH-TEIL 00HEX SCHREIBEN
	MOVWF	DAT_H			;NUR ZUR SICHERHEIT

	MOVF	DAT, W			;IN LOW-TEIL DAS EMPFANGENE DAT-REGISTER
	MOVWF	DAT_L

	CALL	WRITE

	MOVF	ADRX_L, W
	MOVWF	ADR_L
	MOVF	ADRX_H, W
	MOVWF	ADR_H

	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN

ANFX	CALL	F_RX			;WAS ABGESPEICHERT WERDEN SOLL WIRD GELESEN
	BTFSS	MERK1, BIT7		;BEI HIGH HAT ES GELESEN
	GOTO	ANFX

	MOVWF	DAT_L
	BCF	MERK1, BIT7		;WIEDER LESE-ERKENNUNG ZURUECK GESETZT WERDEN

	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN

ANFXX	CALL	F_RX			;WAS ABGESPEICHERT WERDEN SOLL WIRD GELESEN
	BTFSS	MERK1, BIT7		;BEI HIGH HAT ES GELESEN
	GOTO	ANFXX

	ANDLW	0X1F
	MOVWF	DAT_H
	BCF	MERK1, BIT7		;WIEDER LESE-ERKENNUNG ZURUECK GESETZT WERDEN

	CALL	WRITE

	MOVLW	0XFF			;ENDE VON RX UND EINSCHREIBEN	
	SUBWF	DAT_L, W
	BTFSC	STATUS, Z
	GOTO	LESE			;ZUM KONTROLLE-LESEN

	INCFSZ	ADR_L, F		;IMMER 1 WEITERZAEHLEN
	GOTO	W0
	INCF	ADR_H, F

W0	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN
	GOTO	ANFX

;-------------- ES WIRD DER FLASH-SPEICHER GELESEN UND DANN WIRD ES AUSGESENDET--------
LESE	BCF	PORTC,RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN

	MOVLW	D'10'			;WARTESCHLEIFE 100MS
	MOVWF	MERK1

LE0	CALL	T10_I	

LE1	BTFSS	INTCON, T0IF		;BEI OVERFLOW = 1 IST ZEIT ERREICHT
	GOTO	LE1
	DECFSZ	MERK1 ,F
	GOTO	LE0

	MOVF	ADRG_L, W
	MOVWF	ADR_L
	MOVF	ADRG_H, W
	MOVWF	ADR_H

	CALL	READ
	MOVF	DAT_L, W		;BEI GESCHWINDIGKEIT NUR LOW-TEIL SENDEN
	MOVWF	DAT

LES1	CALL	F_TX
	BTFSS	MERK1, BIT7
	GOTO	LES1		

	BCF	MERK1, BIT7
;------------------------------------------------------------------------------------

	MOVF	ADRX_L, W
	MOVWF	ADR_L
	MOVF	ADRX_H, W
	MOVWF	ADR_H

LES7	CALL	READ

	MOVF	DAT_L, W		;LOW-TEIL NOTEN AUSSENDEN
	MOVWF	DAT

LES2	CALL	F_TX
	BTFSS	MERK1, BIT7
	GOTO	LES2		

	BCF	MERK1, BIT7

	MOVF	DAT_H, W		;HIGH-TEIL LAENGE AUSSENDEN
	ANDLW	0X1F			;NUR BIT 0-4 AUSWERTEN
	MOVWF	DAT

LES2X	CALL	F_TX
	BTFSS	MERK1, BIT7
	GOTO	LES2X

	BCF	MERK1, BIT7

	MOVLW	0XFF			;ENDE VON TX UND AUSLESEN	
	SUBWF	DAT_L, W
	BTFSC	STATUS, Z
	GOTO	LES3

	INCFSZ	ADR_L, F		;IMMER 1 WEITERZAEHLEN
	GOTO	LES7
	INCF	ADR_H, F
	GOTO	LES7

LES3	BCF	PORTC, BIT3		;SPEICHERKONTROLL-LED LEUCHTET JETZT NICHT MEHR
	GOTO	ANF0

;------------------------------------------------------------------------------------

;*****************************************************************************
;*                              INTERRUPT+24HUHR EIN                         *
;*                              19.09.2005                                   *
;*****************************************************************************
I_EIN	BTFSS	HELP, BIT0
	RETURN

	BSF	PORTC, RTS_OUTPUT 	;AM MAX232 KOMMT LOW RAUS, ES KOENNEN KEINE DATEN
					;EMPFANGEN WERDEN

	BCF	PIR1, TMR1IF		;OVERFLOW 0 MACHEN

	BSF	INTCON, GIE		;ALLGEMEINES INTERRUPT ENABLE
	BSF	INTCON, PEIE

	BANK1
	BSF	PIE1, TMR1IE		;OVERFLOW INTERRUPT BEI TIMER1 ZULASSEN/ENABLE
	BANK0

	MOVLW	0XD8			;500MS/32=15.625MS/0.25S=62500TAKTE
	MOVWF	TMR1L			;0X10000-62500(0XF424)=0X0BDC  +(JUSTAGE)==0X0BD8
	MOVLW	0X0B
	MOVWF	TMR1H

	BSF	PORTC, BIT3		;LED AN ,ES BLITZT SCHON ZU BEGINN EINE 1/2SEC LANG

	BTFSS	PORTB, BIT0		;ABFRAGE OB 24H-WOCHEN- ODER MONATS-ABSPIELUNG
	GOTO	MONAT

	MOVLW	D'0'			;BEGINNT BEI MELODIENUMMER 0
	MOVWF	NR

	MOVLW	D'2'			;2*0.5SEC = 1SEC TAKT BLITZT ES
	MOVWF	SEC1

	MOVLW	D'60'			;JETZT SIND ES 60SEC-ZEIT
	MOVWF	SEC2

	MOVLW	D'60'			;JETZT SIND ES 60MIN-ZEIT
	MOVWF	MIN

	MOVLW	D'24'			;JETZT SIND ES 24H-ZEIT
	MOVWF	H
	GOTO	I_EE
	
MONAT	MOVLW	D'0'			;BEGINNT BEI MELODIENUMMER 0
	MOVWF	NR

	MOVLW	D'6'			;6*0.5SEC = 3SEC TAKT BLITZT ES
	MOVWF	SEC1

	MOVLW	D'20'			;JETZT SIND ES 60SEC-ZEIT
	MOVWF	SEC2

	MOVLW	D'60'			;JETZT SIND ES 60MIN-ZEIT
	MOVWF	MIN

	MOVLW	D'24'			;JETZT SIND ES 24H-ZEIT
	MOVWF	H

I_EE	MOVLW	0X31			;PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
	MOVWF	T1CON			;START TIMER1	

	BCF	HELP, BIT0		;NUR EINMAL INIT
	RETURN
;*****************************************************************************
;*                              INTERRUPT+24HUHR AUS                         *
;*                              19.09.2005                                   *
;*****************************************************************************
I_AUS	BTFSC	HELP, BIT0
	RETURN

AU	BCF	INTCON, GIE		;INTERRUPT ABSCHALTEN SO WIE ES IM BUCH STEHT
	BTFSC	INTCON, GIE
	GOTO	AU

	BCF	INTCON, PEIE

	BANK1
	BCF	PIE1, TMR1IE		;OVERFLOW INTERRUPT BEI TIMER1 ABSCHALTEN/DISABLE
	BANK0

	BCF	PORTC, BIT3		;LED AUS

	BCF	PORTC, RTS_OUTPUT 	;AM MAX232 KOMMT HIGH RAUS, ES KOENNEN DATEN
					;EMPFANGEN WERDEN
	BSF	HELP, BIT0		;NUR EINMAL INIT, SIEHE OBEN
	RETURN
;*****************************************************************************
;*                              ZEIT-LAENGE                                  *
;*                              ES WIRD ABGEBROCHEN WENN ZEIT ERREICHT       *
;*****************************************************************************
Z_LAEN	CALL	T5_I
	DECFSZ	MERK2, F
	GOTO	EY
	DECFSZ	LA, F
	GOTO	SPZ
	BSF	ANZ, BIT3		;ABBRUCH		
	GOTO	EY			;NEUE NOTE

SPZ	MOVF	GESCH, W
	MOVWF	MERK2
EY	RETURN
;*****************************************************************************
;*                              FLASH READ                                   *
;*                              7.11.03                                      *
;*****************************************************************************
READ	MOVF	ADR_L, W		;ADRESSE LOW+HIGH EINTRAGEN
	BANK2				;BANK2
	MOVWF	EEADR
	BANK0				;BANK0
	MOVF	ADR_H, W
	BANK2				;BANK2
	MOVWF	EEADRH

	BANK3				;BANK3
	BSF	EECON1, EEPGD		;PROGRAMM MEMORY AUSWAEHLEN
	BSF	EECON1, RD		;LESEN MIT OBIGER ADRESSE ADR_L/ADR_H
	NOP
	NOP
	BANK2				;BANK2
	MOVF	EEDATA, W		;AUS SPEICHER DATEN LESEN
	BANK0				;BANK0
	MOVWF	DAT_L

	BANK2				;BANK2
	MOVF	EEDATH, W
	BANK0				;BANK0
	MOVWF	DAT_H

	RETURN
;*****************************************************************************
;*                              FLASH WRITE                                  *
;*                              7.11.03                                      *
;*****************************************************************************
WRITE	MOVF	ADR_L, W		;ADRESSE LOW+HIGH EINTRAGEN
	BANK2				;BANK2
	MOVWF	EEADR
	BANK0				;BANK0
	MOVF	ADR_H, W
	BANK2				;BANK2
	MOVWF	EEADRH

	BANK0				;BANK0
	MOVF	DAT_L, W		;DATEN LOW EINTRAGEN
	BANK2				;BANK2
	MOVWF	EEDATA
	BANK0				;BANK0
	MOVF	DAT_H, W		;DATEN HIGH EINTRAGEN
	BANK2				;BANK2
	MOVWF	EEDATH

	BANK3				;BANK3
	BSF	EECON1, EEPGD		;PROGRAMM MEMORY AUSWAEHLEN
	BSF	EECON1, WREN		;ALLOWS WRITE CYCLUS
;	BCF	INTCON, GIE		;INTERRUPT ABSCHALTEN / KANN ENTFALLEN
	MOVLW	0X55
	MOVWF	EECON2	
	MOVLW	0XAA
	MOVWF	EECON2	
	BSF	EECON1, WR		;SCHREIBEN VON DAT_L/DAT_H AUF ADRESSE ADR_L/ADR_H
	NOP
	NOP
;	BSF	INTCON, GIE		;INTERRUPT ANSCHALTEN / KANN ENTFALLEN
	BCF	EECON1, WREN		;KEIN SCHREIBZYKLUS MEHR
	BANK0				;BANK0
	RETURN
;*****************************************************************************
;*                              UNTERPRG. RX                                 *
;*                              28.12.04                                     *
;*****************************************************************************
F_RX	BTFSS	PIR1,RCIF		;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
	GOTO	RXE			;BEI NEIN ZUM ENDE
	BSF	PORTC,RTS_OUTPUT 	;RTS WIRD AM MAX232 LOW, ES KOENNEN KEINE DATEN MEHR
                                        ;                        GESENDET WERDEN

;HIER MUESSTE NOCH ERROR-ABFAGE REIN, WURDE HIER WEGGELASSEN
;HIER WURDE NUR ALLES IN NORMAL-ZUSTAND VERSETZT, DAMIT NICHTS HAENGEN BLEIBT
	BSF	RCSTA, CREN
	BCF	RCSTA, FERR
	BCF	RCSTA, OERR

	MOVF	RCREG,W			;IN W DIE DATEN
	BSF	MERK1,BIT7
	GOTO	RXEE
RXE	BCF	MERK1,BIT7		;ERST WENN ES 1 IST NEUES BYTE LESEN
RXEE	RETURN

;	ERST NACH DEM SPEICHERN RTS AUF HIGH BEIM MAX232
;	BCF	PORTC,RTS_OUTPUT 	;RTS WIRD AM MAX232 HIGH, ES KOENNEN DATEN GESENDET
;                                                                  WERDEN

;*****************************************************************************
;*                              UNTERPRG. TX                                 *
;*                              28.12.04                                     *
;*****************************************************************************
F_TX	BTFSC	PORTC,CTS_INPUT	;IST CTS LOW AM MAX232 KANN NICHT GESENDET WERDEN, 
                                ;BEI HIGH NUR SENDEN
	GOTO	TXE		;DAMIT ES NICHT AUF HIGH WARTET SONST HAENGT ES
				;BEI HIGH AM MAX SPRUNG, ES SENDET
				;MAX OHNE INVERTER ALSO EINE PHASENDREHUNG
	BTFSS	PIR1,TXIF	;CHECK THAT BUFFER IS EMPTY, TXIF IST GESETZT BEI TXEN GESETZT
	GOTO	TXE
	MOVF	DAT, W
	MOVWF	TXREG		;TRANSMIT BYTE
	BSF	MERK1,BIT7
	GOTO	TXEE
TXE	BCF 	MERK1,BIT7	;ERST WENN ES 1 IST NEUES BYTE AUSSENDEN
TXEE	RETURN
;*****************************************************************************
;*                              MELODIEAUSWAHLSCHALTER ABFRAGEN UND          *
;*                              ADRESSEN BERECHNEN                           *
;*                              24.06.06                                     *
;*****************************************************************************
ABF	BTFSC	HELP, BIT0	;ABFRAGE OB I_AUS ODER I_EIN ZU LETZT AKTIV WAREN
	GOTO	ABF1
	MOVF	NR, W
	MOVWF	MERK1
	GOTO	ABF2

ABF1	MOVF 	PORTB, W	; LESE PORT B IN W  , ALSO MELODIE-AUSWAHLSCHALTER-ABFRAGE
	ANDLW 	0X1F		; NUR BIT0-4 AUSWERTEN
	MOVWF	MERK1

ABF2	MOVLW	MEG_H		;ANFANGS-ADRESSE FUER GESCHWINDIGKEIT
	MOVWF	ADRG_H		;LADEN
	MOVLW	MEG_L
	MOVWF	ADRG_L

	MOVLW	MEL_H		;ANFANGS-ADRESSE FUER NOTEN+LAENGE
	MOVWF	ADRX_H		;LADEN
	MOVLW	MEL_L
	MOVWF	ADRX_L

	MOVLW	0X00		;MIT MELODIE0 BEGINNT VERGLEICHSUCHE
	MOVWF	MERK3

ABF3	SUBWF	MERK1, W	;VERGLEICH MIT MERK1-SCHALTER-BITS UND MELODIE-ZAEHLUNG MERK3
	BTFSC	STATUS, Z
	GOTO	AB0	

	INCFSZ	ADRG_L, F	;NEUE GESCHWINDIGKEITSADRESSE
	GOTO	ABF4
	INCF	ADRG_H, F

ABF4	MOVF	ADRX_L, W	;NEUE NOTEN+LAENGEN-ADRESSE BERECHNEN
	ADDLW	M_LAEN
	BTFSC	STATUS, C	
	INCF	ADRX_H, F
	MOVWF	ADRX_L

	INCF	MERK3, F	;NACH NEUER SCHALTERSTELLUNG SUCHEN OB DIESE JETZT STIMMT
	MOVF	MERK3, W
	GOTO	ABF3

AB0	RETURN
;*****************************************************************************
;*                            TIMER0  INIT  10MSEC                           *
;*                              13.05.04                                     *
;*****************************************************************************
T10_I	MOVLW	D'217'
	MOVWF	TMR0
	BCF	INTCON, T0IF	;OVERFLOW = 0
	RETURN

;ZEITBERECHNUNG 10MS
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.25S=256S
;256S*D'39'=9,984MS
;TMR0 ALSO D'256'-D'39'=D'217' ENTSPRICHT CA. 10MS
;*****************************************************************************
;*                            TIMER0  INIT  5MSEC                            *
;*                              13.05.04                                     *
;*****************************************************************************
T5_I	MOVLW	D'237'
	MOVWF	TMR0
	BCF	INTCON, T0IF	;OVERFLOW = 0
	RETURN

;ZEITBERECHNUNG 5MS=FUER NOTENLAENGE
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.25S=256S
;256S*D'19'=4,864MS
;TMR0 ALSO D'256'-D'19'=D'237' ENTSPRICHT CA. 5MS
;*****************************************************************************
;*                            TIMER0  INIT  3MSEC                            *
;*                              13.05.04                                     *
;*****************************************************************************
T3_I	MOVLW	D'244'
	MOVWF	TMR0
	BCF	INTCON, T0IF	;OVERFLOW = 0
	RETURN

;ZEITBERECHNUNG 3MS=FUER NOTENLAENGE
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.25S=256S
;256S*D'12'=3,075MS
;TMR0 ALSO D'256'-D'12'=D'244' ENTSPRICHT CA. 3MS



	ORG 0300H
;*****************************************************************************
;*                             TON-HOEHE                                     *
;*                              27.05.04                                     *
;*                                                                           *
;*                                                                           *
;*****************************************************************************
HOEHE	MOVLW H'03'		;ADRESSE SPEICHERN NEUES PCLATH
	MOVWF PCLATH

	MOVF 	DAT_L, W	; SPRUNGWERT DER TONHOEHE (SCHLEIFENANZAHL)
	ADDWF 	PCL,F		; AUF STELLE DES ZU LESENDEN BYTES BRINGEN

	RETLW D'0'	;PAUSE
	RETLW D'255'	;C_T
	RETLW D'240'	;CIS_T
	RETLW D'227'	;D_T
	RETLW D'214'	;DIS_T
	RETLW D'202'	;E_T
	RETLW D'191'	;F_T
	RETLW D'180'	;FIS_T
	RETLW D'170'	;G_T
	RETLW D'160'	;GIS_T
	RETLW D'151'	;A_T
	RETLW D'143'	;AIS_T
	RETLW D'135'	;H_T

	RETLW D'127'	;C
	RETLW D'120'	;CIS
	RETLW D'113'	;D
	RETLW D'107'	;DIS
	RETLW D'101'	;E
	RETLW D'95'	;F
	RETLW D'90'	;FIS
	RETLW D'85'	;G
	RETLW D'80'	;GIS
	RETLW D'76'	;A
	RETLW D'72'	;AIS
	RETLW D'67'	;H

	RETLW D'64'	;C_H
	RETLW D'60'	;CIS_H
	RETLW D'57'	;D_H
	RETLW D'54'	;DIS_H
	RETLW D'51'	;E_H
	RETLW D'48'	;F_H
	RETLW D'45'	;FIS_H
	RETLW D'43'	;G_H
	RETLW D'40'	;GIS_H
	RETLW D'38'	;A_H
	RETLW D'36'	;AIS_H

	ORG 032AH
;*****************************************************************************
;*                             TON-LAENGE                                    *
;*                              27.05.04                                     *
;*                                                                           *
;*                                                                           *
;*****************************************************************************
LAENGE	MOVLW H'03'		;ADRESSE SPEICHERN NEUES PCLATH
	MOVWF PCLATH

	MOVF 	DAT_H, W	; SCHLEIFENANZAHL DER TONLAENGE
	ANDLW 	0X1F		; NUR BIT0-4 AUSWERTEN

	ADDWF 	PCL,F		; AUF STELLE DES ZU LESENDEN BYTES BRINGEN

	RETLW D'48'	;1_V	48*5MS=240MS  5MS=TIMER0-ZEIT
	RETLW D'32'	;1
	RETLW D'24'	;1/2_V
	RETLW D'16'	;1/2
	RETLW D'12'	;1/4_V
	RETLW D'8'	;1/4
	RETLW D'6'	;1/8_V
	RETLW D'4'	;1/8
	RETLW D'3'	;1/16_V
	RETLW D'2'	;1/16	2*5MS=10MS  5MS=TIMER0-ZEIT


	END
